var lphi lh lc ly lw lwtar lpai la
lmpl lmrs lmup lmuw lnc;
varexo ua;
parameters beta sigma phi psi epsilon alpha 
deltaw kappa rhoa g_ss s;

% parameter values
beta = 0.99;
sigma = 2;
epsilon = 6;
psi = 20;
alpha = 0.9;
phi = 2;
rhoa = 0.95;
gy_ss = 0.25;

deltaw = 0;

% steady state
s = 0; //epsilon/(epsilon-1)-1;
phi_ss = (epsilon-1)/epsilon*(1+s);

h_ss = 1;
n_ss = 1;
y_ss = h_ss^alpha*n_ss;

c_ss = (1-gy_ss)*y_ss;
g_ss = gy_ss*y_ss;
kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

mpl_ss = alpha*h_ss^(alpha-1);
mrs_ss = kappa*h_ss^phi*c_ss^sigma;
w_ss = mrs_ss;
mup_ss = mpl_ss/w_ss;
muw_ss = w_ss/mrs_ss;
nc_ss = h_ss;

model;

exp(ly) = exp(lc) + g_ss + psi/2*(exp(lpai)-1)^2;
exp(ly) = exp(la + alpha*lh);

psi*(exp(lpai)-1)*exp(lpai) = (1-epsilon)*exp(ly)*(1+s-epsilon/(epsilon-1)*exp(lphi))
+ beta*exp(-sigma*(lc(+1)-lc))*psi*(exp(lpai(+1))-1)*exp(lpai(+1));

exp(lphi + lmpl - lw) = 1;
exp(lmrs - lwtar) = 1;

exp(lw) = deltaw*exp(lw(-1)) + (1-deltaw)*exp(lwtar);

la = rhoa*la(-1) + ua;

exp(lmpl) = alpha*exp(la + (alpha-1)*lh);
exp(lmrs) = kappa*exp(phi*lh + sigma*lc);
exp(lmup) = exp(lmpl-lw);
exp(lmuw) = exp(lw-lmrs); 
exp(lnc) = exp(lh);

end;

initval;
lphi = log(phi_ss);
lh = log(h_ss);
lc = log(c_ss);
ly = log(y_ss);
lw = log(w_ss);
lwtar = lw;
lpai = 0;
la = 0;
lmpl = log(mpl_ss);
lmrs = log(mrs_ss);
lmup = log(mup_ss);
lmuw = log(muw_ss);
lnc = log(nc_ss);
end;

shocks;
var ua; stderr 0.008*100;
end;

planner_objective( exp((1-sigma)*lc)/(1-sigma) 
- kappa*exp((1+phi)*lh)/(1+phi) );

// Figure 1 and 2
deltaw = 0;
ramsey_policy(planner_discount=0.99,irf=31,nograph) lw lh lmup lmuw lnc lpai ly lc;
save irramcomp lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;

// Figure 3
deltaw = 0.9;
ramsey_policy(irf=31,nograph) lw lh lmup lmuw lnc lpai ly lc;
save irramcomp_rwr lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;