var ltheta lv lu lna lphi lh lc ly lw lwtar lm lp lq lpai la
lchi ldelta lzeta lmpl lmrs lmup lmuw lnc lg;
varexo ua ug;
parameters beta sigma phi rho xi cv psi epsilon alpha eta 
deltaw mbar b kappa rhoa rhog g_ss s;

% parameter values
beta = 0.99;
sigma = 2;
epsilon = 6;
psi = 20;
xi = 0.4;
rho = 0.1;
eta = 0.6;
bw = 0.6;
alpha = 0.9;
phi = 2;
utilde_ss = 0.4;
q_ss = 0.7;
rhoa = 0.95;
rhog = 0.9;
gy_ss = 0.25;

deltaw = 0;

% steady state
s = 0; //epsilon/(epsilon-1)-1;
phi_ss = (epsilon-1)/epsilon*(1+s);
n_ss = 1-utilde_ss;
m_ss = rho*n_ss;
v_ss = m_ss/q_ss;
u_ss = 1-n_ss+rho*n_ss;
theta_ss = v_ss/u_ss;
mbar = m_ss/u_ss^xi/v_ss^(1-xi);
p_ss = m_ss/u_ss;

h_ss = 1;
y_ss = h_ss^alpha*n_ss;

wh_ss = phi_ss*alpha*h_ss^alpha;
J_ss = (1-alpha)*phi_ss*h_ss^alpha/(1-beta*(1-rho));
cv = q_ss*J_ss;
w_ss = wh_ss/h_ss;
b = bw*wh_ss;
c_ss = (1-gy_ss)*y_ss - cv*v_ss + (1-n_ss)*b;
g_ss = gy_ss*y_ss;
delta_ss = (1-eta)*((1+phi)*(1-bw)-alpha)*(1-beta*(1-rho))*alpha ...
/ (eta*(1-beta*(1-rho)*(1-p_ss))*(1+phi)*(1-alpha) ...
+ (1-eta)*(1-beta*(1-rho))*alpha*(1-alpha));
S_ss = eta/(1-eta)*delta_ss*J_ss;
chi_ss = eta*delta_ss/(1-eta*(1-delta_ss));
kappa = ((1-bw)*wh_ss-(1-beta*(1-rho)*(1-p_ss))*S_ss) / (h_ss^(1+phi)*c_ss^sigma/(1+phi));

mpl_ss = alpha*h_ss^(alpha-1);
mrs_ss = kappa*h_ss^phi*c_ss^sigma;
mup_ss = mpl_ss/w_ss;
muw_ss = w_ss/mrs_ss;
nc_ss = n_ss*h_ss;

model;

exp(lu) = 1 - (1-rho)*exp(lna(-1));
exp(ltheta) = exp(lv - lu);
exp(lna) = (1-rho)*exp(lna(-1)) + exp(lm);
exp(lp) = exp(lm - lu);
exp(lq) = exp(lm - lv);
exp(lm) = mbar*exp(xi*lu + (1-xi)*lv);
exp(ly) = exp(lc) + exp(lg) + cv*exp(lv) + psi/2*(exp(lpai)-1)^2 - (1-exp(lna))*b;
exp(ly) = exp(la + alpha*lh + lna);

psi*(exp(lpai)-1)*exp(lpai) = (1-epsilon)*exp(ly)*(1+s-epsilon/(epsilon-1)*exp(lphi))
+ beta*exp(-sigma*(lc(+1)-lc))*psi*(exp(lpai(+1))-1)*exp(lpai(+1));

cv*exp(-lq) = exp(lphi + la + alpha*lh) - exp(lw + lh)
+ beta*(1-rho)*exp(-sigma*(lc(+1)-lc))*cv*exp(-lq(+1));

exp(lphi + lmpl - lw) = 1;

exp(lwtar + lh) = exp(lchi)*exp(lphi + la + alpha*lh) 
+ (1-exp(lchi))*(kappa/(1+phi)*exp((1+phi)*lh + sigma*lc) + b)
+ exp(lchi)*beta*(1-rho)*exp(-sigma*(lc(+1)-lc))
* (1-exp(lzeta(+1))*(1-exp(lp(+1))))*cv*exp(-lq(+1));

exp(lchi) = eta*exp(ldelta)/(1-eta*(1-exp(ldelta)));

exp(ldelta) = (exp(lmrs-lwtar)-alpha)/(1-alpha);

exp(lzeta) = exp(ldelta-ldelta(-1));

exp(lw) = deltaw*exp(lw(-1)) + (1-deltaw)*exp(lwtar);

la = rhoa*la(-1) + ua;
lg = (1-rhog)*log(g_ss) + rhog*lg(-1) + ug;

exp(lmpl) = alpha*exp(la + (alpha-1)*lh);
exp(lmrs) = kappa*exp(phi*lh + sigma*lc);
exp(lmup) = exp(lmpl-lw);
exp(lmuw) = exp(lw-lmrs); 
exp(lnc) = exp(lna+lh);

end;

initval;
ltheta = log(theta_ss);
lv = log(v_ss);
lu = log(u_ss);
lna = log(n_ss);
lphi = log(phi_ss);
lh = log(h_ss);
lc = log(c_ss);
ly = log(y_ss);
lw = log(w_ss);
lwtar = lw;
lm = log(m_ss);
lp = log(p_ss); 
lq = log(q_ss); 
lchi = log(chi_ss);
ldelta = log(delta_ss);
lzeta = 0;
lpai = 0;
la = 0;
lmpl = log(mpl_ss);
lmrs = log(mrs_ss);
lmup = log(mup_ss);
lmuw = log(muw_ss);
lnc = log(nc_ss);
end;

shocks;
var ua; stderr 0.008*100;
//var ug; stderr 0.0074*100;
end;

planner_objective( exp((1-sigma)*lc)/(1-sigma) - exp(lna)*kappa*exp((1+phi)*lh)/(1+phi) );

// Figure 1 and 2
deltaw = 0;
ramsey_policy(planner_discount=0.99,irf=31,nograph) lw ltheta lna lh lmup lmuw lnc lpai ly lc;
save irramrtm ltheta_ua lna_ua lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;

// Figure 3
deltaw = 0.9;
ramsey_policy(irf=31,nograph) lw ltheta lna lh lmup lmuw lnc lpai ly lc;
save irramrtm_rwr ltheta_ua lna_ua lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;