var ltheta lv lu lna lphi lh lc ly lw lwtar lm lp lq lpai la
lmpl lmrs lmup lmuw lnc;
varexo ua;
parameters beta sigma phi rho xi cv psi epsilon alpha eta 
deltaw mbar b kappa rhoa g_ss s;

% parameter values
beta = 0.99;
sigma = 2;
epsilon = 6;
psi = 20;
xi = 0.4;
rho = 0.1;
eta = 0.6;
bw = 0.6;
alpha = 0.9;
phi = 2;
utilde_ss = 0.4;
q_ss = 0.7;
rhoa = 0.95;
gy_ss = 0.25;

deltaw = 0;

% steady state
s = 0; //epsilon/(epsilon-1)-1;
phi_ss = (epsilon-1)/epsilon*(1+s);
n_ss = 1-utilde_ss;
m_ss = rho*n_ss;
v_ss = m_ss/q_ss;
u_ss = 1-n_ss+rho*n_ss;
theta_ss = v_ss/u_ss;
mbar = m_ss/u_ss^xi/v_ss^(1-xi);
p_ss = m_ss/u_ss;

h_ss = 1;
y_ss = h_ss^alpha*n_ss;

wh_ss = (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*alpha/(1+phi)) ...
/ (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*(1-bw)) ...
* phi_ss*h_ss^alpha;
J_ss = (phi_ss*h_ss^alpha - wh_ss)/(1-beta*(1-rho));
cv = q_ss*J_ss;
w_ss = wh_ss/h_ss;
b = bw*wh_ss;
c_ss = (1-gy_ss)*y_ss - cv*v_ss + (1-n_ss)*b;
g_ss = gy_ss*y_ss;
kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

mpl_ss = alpha*h_ss^(alpha-1);
mrs_ss = kappa*h_ss^phi*c_ss^sigma;
mup_ss = mpl_ss/w_ss;
muw_ss = w_ss/mrs_ss;
nc_ss = n_ss*h_ss;

bwbar = 1-1/muw_ss/(1+phi);

model;

exp(lu) = 1 - (1-rho)*exp(lna(-1));
exp(ltheta) = exp(lv - lu);
exp(lna) = (1-rho)*exp(lna(-1)) + exp(lm);
exp(lp) = exp(lm - lu);
exp(lq) = exp(lm - lv);
exp(lm) = mbar*exp(xi*lu + (1-xi)*lv);
exp(ly) = exp(lc) + g_ss + cv*exp(lv) + psi/2*(exp(lpai)-1)^2 - (1-exp(lna))*b;
exp(ly) = exp(la + alpha*lh + lna);

psi*(exp(lpai)-1)*exp(lpai) = (1-epsilon)*exp(ly)*(1+s-epsilon/(epsilon-1)*exp(lphi))
+ beta*exp(-sigma*(lc(+1)-lc))*psi*(exp(lpai(+1))-1)*exp(lpai(+1));

cv*exp(-lq) = exp(lphi + la + alpha*lh) - exp(lw + lh)
+ beta*(1-rho)*exp(-sigma*(lc(+1)-lc))*cv*exp(-lq(+1));

exp(lphi + lmpl - lmrs) = 1;

exp(lwtar + lh) = eta*exp(lphi + la + alpha*lh) 
+ (1-eta)*(kappa/(1+phi)*exp((1+phi)*lh + sigma*lc) + b)
+ eta*beta*(1-rho)*exp(-sigma*(lc(+1)-lc))*cv*exp(ltheta(+1));

exp(lw) = deltaw*exp(lw(-1)) + (1-deltaw)*exp(lwtar);

la = rhoa*la(-1) + ua;

exp(lmpl) = alpha*exp(la + (alpha-1)*lh);
exp(lmrs) = kappa*exp(phi*lh + sigma*lc);
exp(lmup) = exp(lmpl-lw);
exp(lmuw) = exp(lw-lmrs); 
exp(lnc) = exp(lna+lh);

end;

initval;
ltheta = log(theta_ss);
lv = log(v_ss);
lu = log(u_ss);
lna = log(n_ss);
lphi = log(phi_ss);
lh = log(h_ss);
lc = log(c_ss);
ly = log(y_ss);
lw = log(w_ss);
lwtar = lw;
lm = log(m_ss);
lp = log(p_ss); 
lq = log(q_ss); 
lpai = 0;
la = 0;
lmpl = log(mpl_ss);
lmrs = log(mrs_ss);
lmup = log(mup_ss);
lmuw = log(muw_ss);
lnc = log(nc_ss);
end;

shocks;
var ua; stderr 0.008*100;
end;

planner_objective( exp((1-sigma)*lc)/(1-sigma) 
- exp(lna)*kappa*exp((1+phi)*lh)/(1+phi) );

bvec = [0.01:0.005:0.99]';

for i=1:length(bvec)

    eta = bvec(i);

    phi_ss = (epsilon-1)/epsilon*(1+s);
    wh_ss = (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*alpha/(1+phi)) ...
    / (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*(1-bw)) ...
    * phi_ss*h_ss^alpha;
    J_ss = (phi_ss*h_ss^alpha - wh_ss)/(1-beta*(1-rho));
    cv = q_ss*J_ss;
    w_ss = wh_ss/h_ss;
    b = bw*wh_ss;
    c_ss = (1-gy_ss)*y_ss - cv*v_ss + (1-n_ss)*b;
    g_ss = gy_ss*y_ss;
    kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

    mpl_ss = alpha*h_ss^(alpha-1);
    mrs_ss = kappa*h_ss^phi*c_ss^sigma;
    mup_ss = mpl_ss/w_ss;
    muw_ss = w_ss/mrs_ss;
    nc_ss = n_ss*h_ss;

    ramsey_policy(planner_discount=beta,nograph) lpai lmup lmuw;
    pvec(i) = oo_.var(1,1)^.5;
    mupvec(i) = oo_.var(2,2)^.5;
    muwvec(i) = oo_.var(3,3)^.5;

end

save bmebpvec_eta bvec pvec;