var lphi lh lc ly lw lwtar lpai la
lmpl lmrs lmup lmuw lnc;
varexo ua;
parameters beta sigma phi psi epsilon alpha 
deltaw kappa rhoa g_ss s
w_ss cy_ss gy_ss phi_ss kappap c_ss muw_ss;

% parameter values
beta = 0.99;
sigma = 2;
epsilon = 6;
psi = 20;
alpha = 0.9;
phi = 2;
rhoa = 0.95;
gy_ss = 0.25;

deltaw = 0;

% steady state
s = epsilon/(epsilon-1)-1;
phi_ss = (epsilon-1)/epsilon*(1+s);

h_ss = 1;
n_ss = 1;
y_ss = h_ss^alpha*n_ss;

c_ss = (1-gy_ss)*y_ss;
g_ss = gy_ss*y_ss;
kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

mpl_ss = alpha*h_ss^(alpha-1);
mrs_ss = kappa*h_ss^phi*c_ss^sigma;
w_ss = mrs_ss;
mup_ss = mpl_ss/w_ss;
muw_ss = w_ss/mrs_ss;
nc_ss = h_ss;

cy_ss = c_ss/y_ss;
kappap = epsilon*phi_ss*y_ss/psi;

model;

ly = cy_ss*lc;
ly = la + alpha*lh;

lpai = kappap*lphi + beta*lpai(+1);

lphi + lmpl - lw = 0;
lmrs - lwtar = 0;

lw = deltaw*lw(-1) + (1-deltaw)*lwtar;

la = rhoa*la(-1) + ua;

lmpl = la + (alpha-1)*lh;
lmrs = phi*lh + sigma*lc;
lmup = lmpl - lw;
lmuw = lw - lmrs;
lnc = lh;

end;

shocks;
var ua; stderr 0.008*100;
end;

planner_objective( 
- psi/c_ss*lpai^2 - sigma*lc^2 + 1/cy_ss*(ly^2 - alpha*(1+phi)*lh^2) );

// Figure 6
deltaw = 0;
ramsey_policy(planner_discount=0.99,irf=31,nograph) lw lh lmup lmuw lnc lpai ly lc;
save irramcomp_lq lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;

// Figure 7
deltaw = 0.9;
ramsey_policy(irf=31,nograph) lw lh lmup lmuw lnc lpai ly lc;
save irramcomp_rwr_lq lw_ua lh_ua lpai_ua lmup_ua lmuw_ua mup_ss muw_ss;