var ltheta lv lu lna lphi lh lc ly lw lwtar lm lp lq lpai la
lmpl lmrs lmup lmuw lnc;
varexo ua;
parameters beta sigma phi rho xi cv psi epsilon alpha eta 
deltaw mbar b kappa rhoa g_ss s 
p_ss q_ss w_ss cy_ss gy_ss vy_ss ny_ss phi_ss kappap c_ss;

% parameter values
beta = 0.99;
sigma = 2;
epsilon = 6;
psi = 20;
xi = 0.4;
rho = 0.1;
eta = 0.6;
bw = 0.6;
alpha = 0.9;
phi = 2;
utilde_ss = 0.4;
q_ss = 0.7;
rhoa = 0.95;
gy_ss = 0.25;

deltaw = 0;

% Hosios condition for RTM
A = (1-beta*(1-rho)*(1-rho/(1/(1-utilde_ss)-1+rho)))*(1+phi)*(1-alpha);
B = ((1+phi)*(1-bw)-1)*(1-beta*(1-rho))*alpha;
eta_star = B/(A+B);
eta = eta_star;
xi = eta;

% steady state
s = epsilon/(epsilon-1)-1;
phi_ss = (epsilon-1)/epsilon*(1+s);
n_ss = 1-utilde_ss;
m_ss = rho*n_ss;
v_ss = m_ss/q_ss;
u_ss = 1-n_ss+rho*n_ss;
theta_ss = v_ss/u_ss;
mbar = m_ss/u_ss^xi/v_ss^(1-xi);
p_ss = m_ss/u_ss;

h_ss = 1;
y_ss = h_ss^alpha*n_ss;

wh_ss = (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*alpha/(1+phi)) ...
/ (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*(1-bw)) ...
* phi_ss*h_ss^alpha;
J_ss = (phi_ss*h_ss^alpha - wh_ss)/(1-beta*(1-rho));
cv = q_ss*J_ss;
w_ss = wh_ss/h_ss;
b = bw*wh_ss;
c_ss = (1-gy_ss)*y_ss - cv*v_ss + (1-n_ss)*b;
g_ss = gy_ss*y_ss;
kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

mpl_ss = alpha*h_ss^(alpha-1);
mrs_ss = kappa*h_ss^phi*c_ss^sigma;
mup_ss = mpl_ss/w_ss;
muw_ss = w_ss/mrs_ss;
nc_ss = n_ss*h_ss;

cy_ss = c_ss/y_ss;
vy_ss = v_ss/y_ss;
ny_ss = n_ss/y_ss;
kappap = epsilon*phi_ss*y_ss/psi;

model(linear);

lu = -(1-rho)/rho*p_ss*lna(-1);
ltheta = lv - lu;
lna = (1-rho)*lna(-1) + rho*lm;
lp = lm - lu;
lq = lm - lv;
lm = xi*lu + (1-xi)*lv;
ly  = cy_ss*lc + cv*vy_ss*lv + b*ny_ss*lna;
ly = la + alpha*lh + lna;

lpai = kappap*lphi + beta*lpai(+1);

(cv/q_ss)*(-lq) = phi_ss/ny_ss*(lphi + la + alpha*lh)
- w_ss*(lw + lh)
+ beta*(1-rho)*(cv/q_ss)*(-sigma*(lc(+1)-lc)-lq(+1));

lphi + lmpl - lmrs = 0;

w_ss*(lwtar + lh) = eta*phi_ss/ny_ss*(lphi + la + alpha*lh)
+ (1-eta)*alpha*phi_ss/ny_ss/(1+phi)*((1+phi)*lh + sigma*lc)
+ eta*beta*(1-rho)*(cv*p_ss/q_ss)*(-sigma*(lc(+1)-lc)+ltheta(+1));

lw = deltaw*lw(-1) + (1-deltaw)*lwtar;

la = rhoa*la(-1) + ua;

lmpl = la + (alpha-1)*lh;
lmrs = phi*lh + sigma*lc;
lmup = lmpl - lw;
lmuw = lw - lmrs;
lnc = lna + lh;

end;

shocks;
var ua; stderr 0.008*100;
end;

planner_objective( 
- psi/c_ss*lpai^2 - sigma*lc^2 + 1/cy_ss*(ly^2 - lna^2)
+ alpha/cy_ss/(1+phi)  * ( lna^2 - ((1+phi)*lh + lna)^2 )
- cv*vy_ss/cy_ss/(1-xi)* ( xi*lu^2 + (1-xi)*lv^2 - lm^2 ) );

bvec = [0.01:0.005:0.99]';

for i=1:length(bvec)

    eta = bvec(i);

    phi_ss = (epsilon-1)/epsilon*(1+s);
    wh_ss = (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*alpha/(1+phi)) ...
    / (eta*(1-beta*(1-rho)*(1-p_ss)) + (1-eta)*(1-beta*(1-rho))*(1-bw)) ...
    * phi_ss*h_ss^alpha;
    J_ss = (phi_ss*h_ss^alpha - wh_ss)/(1-beta*(1-rho));
    cv = q_ss*J_ss;
    w_ss = wh_ss/h_ss;
    b = bw*wh_ss;
    c_ss = (1-gy_ss)*y_ss - cv*v_ss + (1-n_ss)*b;
    g_ss = gy_ss*y_ss;
    kappa = phi_ss*alpha*h_ss^(alpha-phi-1)/c_ss^sigma;

    mpl_ss = alpha*h_ss^(alpha-1);
    mrs_ss = kappa*h_ss^phi*c_ss^sigma;
    mup_ss = mpl_ss/w_ss;
    muw_ss = w_ss/mrs_ss;
    nc_ss = n_ss*h_ss;

    ramsey_policy(planner_discount=0.99,nograph) lpai lmup lmuw;
    pvec(i) = oo_.var(1)^.5;
    mupvec(i) = oo_.var(2)^.5;
    muwvec(i) = oo_.var(3)^.5;

end

save bmeblinpvec_eta_subs bvec pvec eta_star;